using System;
using System.Data;
using System.Data.SqlClient;

using Seguridad.DataSetFT;
using Municipalidad.Utils;
using Seguridad.DataModel;

namespace Seguridad.DataAccess
{
	public class Permisos: PermisosCRUD
	{
		//Field para almacenar la conexión
		private SqlConnection _connection = null;

		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="connection"></param>
		public Permisos(SqlConnection connection): base(connection)
		{
			_connection = connection;
		}

		#region Mazars

		/// <summary>
		/// 
		/// </summary>
		/// <returns></returns>
		public DSPermisosByUsuarioAndSistema SelectPermisos(int idSistema, int IdUsuario)
		{
			//Almacena retorno del SqlCommand
			DataSet ds;

			try
			{
				//Ejecuta el SqlCommand
				ds = UtilsDB.ExecuteDataset(_connection, CommandType.StoredProcedure, Schema.Permisos.SP_SELECT_PERMISOS_BY_USUARIO, 
					UtilsDB.MP("@idSistema", SqlDbType.Int, 4, idSistema),
					UtilsDB.MP("@idUsuario", SqlDbType.Int, 4, IdUsuario));
			}
			catch (Exception ex)
			{
				throw ex;
			}

			return GetPermisosByUsuarioAndSistemaDSFT(ds);
		}

		/// <summary>
		/// 
		/// </summary>
		/// <returns></returns>
		public DSPermisosByUsuarioAndSistema SelectPermisos(int idSistema, int IdUsuario, string idSucursal)
		{
			//Almacena retorno del SqlCommand
			DataSet ds;

			try
			{
				//Ejecuta el SqlCommand
				ds = UtilsDB.ExecuteDataset(_connection, CommandType.StoredProcedure, Schema.Permisos.SP_SELECT_PERMISOS_BY_USUARIO_AND_SUCURSAL, 
					UtilsDB.MP("@idSistema", SqlDbType.Int, 4, idSistema),
					UtilsDB.MP("@idUsuario", SqlDbType.Int, 4, IdUsuario),
					UtilsDB.MP("@idSucursal", SqlDbType.VarChar, 3, idSucursal));
			}
			catch (Exception ex)
			{
				throw ex;
			}

			return GetPermisosByUsuarioAndSistemaDSFT(ds);
		}

		internal DSPermisosByUsuarioAndSistema GetPermisosByUsuarioAndSistemaDSFT(DataSet ds)
		{
			DSPermisosByUsuarioAndSistema DSFT = new DSPermisosByUsuarioAndSistema();
			DataRow rowDS;

			if (ds.Tables.Count == 0)
				return DSFT;
			foreach(DataRow dr in ds.Tables[0].Rows)
			{
				rowDS = DSFT.Tables[0].NewRow();

				foreach(DataColumn dc in DSFT.Tables[0].Columns)
				{
					rowDS[dc.ColumnName] =  dr[dc.ColumnName];
				}
				DSFT.Tables[0].Rows.Add(rowDS);
			}

			return DSFT;
		}

		#endregion
	}
}